/* assumes WORD = 16bit, BYTE = 8bit!! */
typedef unsigned short WORD;
typedef unsigned char BYTE;

/* Macros for convenience */
#define A a_reg
#define X x_reg
#define Y y_reg
#define P flag_reg
#define S s_reg
#define PC pc_reg

extern int get6502memory(WORD addr);
extern void put6502memory(WORD addr, BYTE byte);
extern void load_image();

/* Address mask. Atari Asteroids/Deluxe use 0x7fff -
 * but use 0xffff for full 16 bit decode
 */
extern WORD addrmask;

/* pointer to the game memory map */
extern BYTE *gameImage;

/* must be called first to initialise all 6502 engines arrays */
extern void init6502(void);

/* sets all of the 6502 registers. The program counter is set from
 * locations $FFFC and $FFFD masked with the above addrmask
 */
extern void reset6502(void);

/* run the 6502 engine for specified number of clock cycles */
extern long exec6502(int timerTicks);

extern void adc6502();
extern void and6502();
extern void asl6502();
extern void asla6502();
extern void bcc6502();
extern void bcs6502();
extern void beq6502();
extern void bit6502();
extern void bmi6502();
extern void bne6502();
extern void bpl6502();
extern void brk6502();
extern void bvc6502();
extern void bvs6502();
extern void clc6502();
extern void cld6502();
extern void cli6502();
extern void clv6502();
extern void cmp6502();
extern void cpx6502();
extern void cpy6502();
extern void dec6502();
extern void dex6502();
extern void dey6502();
extern void eor6502();
extern void inc6502();
extern void inx6502();
extern void iny6502();
extern void jmp6502();
extern void jsr6502();
extern void lda6502();
extern void ldx6502();
extern void ldy6502();
extern void lsr6502();
extern void lsra6502();
extern void nop6502();
extern void ora6502();
extern void pha6502();
extern void php6502();
extern void pla6502();
extern void plp6502();
extern void rol6502();
extern void rola6502();
extern void ror6502();
extern void rora6502();
extern void rti6502();
extern void rts6502();
extern void sbc6502();
extern void sec6502();
extern void sed6502();
extern void sei6502();
extern void sta6502();
extern void stx6502();
extern void sty6502();
extern void tax6502();
extern void tay6502();
extern void tsx6502();
extern void txa6502();
extern void txs6502();
extern void tya6502();
extern void bra6502();
extern void dea6502();
extern void ina6502();
extern void phx6502();
extern void plx6502();
extern void phy6502();
extern void ply6502();
extern void stz6502();
extern void tsb6502();
extern void trb6502();
